Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | File List | Namespace Members | Class Members | File Members

# PK_MessageAccumulator Class Reference

`#include <cryptlib.h>`

Inheritance diagram for PK_MessageAccumulator:

List of all members.

## Detailed Description

interface for accumulating messages to be signed or verified

Only Update() should be called on this class. No other functions inherited from HashTransformation should be called.

Definition at line 1251 of file cryptlib.h.

## Public Member Functions
unsigned int | DigestSize () const
| should not be called on PK_MessageAccumulator
void | TruncatedFinal (byte *digest, unsigned int digestSize)
| should not be called on PK_MessageAccumulator
virtual void | Update (const byte *input, unsigned int length)=0
| process more input
virtual byte * | CreateUpdateSpace (unsigned int &size)
| request space to write input into
virtual void | Final (byte *digest)
| compute hash for current message, then restart for a new message
virtual void | Restart ()
| discard the current state, and restart with a new message
virtual unsigned int | BlockSize () const
| block size of underlying compression function, or 0 if not block based
virtual unsigned int | OptimalBlockSize () const
| input to Update() should have length a multiple of this for optimal speed
virtual unsigned int | OptimalDataAlignment () const
| returns how input should be aligned for optimal performance
virtual void | CalculateDigest (byte *digest, const byte *input, unsigned int length)
| use this if your input is in one piece and you don't want to call Update() and Final() separately
virtual bool | Verify (const byte *digest)
| verify that digest is a valid digest for the current message, then reinitialize the object
virtual bool | VerifyDigest (const byte *digest, const byte *input, unsigned int length)
| use this if your input is in one piece and you don't want to call Update() and Verify() separately
virtual void | CalculateTruncatedDigest (byte *digest, unsigned int digestSize, const byte *input, unsigned int length)
| truncated version of CalculateDigest()
virtual bool | TruncatedVerify (const byte *digest, unsigned int digestLength)
| truncated version of Verify()
virtual bool | VerifyTruncatedDigest (const byte *digest, unsigned int digestLength, const byte *input, unsigned int length)
| truncated version of VerifyDigest()
virtual std::string | AlgorithmName () const
| returns name of this algorithm, not universally implemented yet
virtual Clonable * | Clone () const
| this is not implemented by most classes yet
## Protected Member Functions
void | ThrowIfInvalidTruncatedSize (unsigned int size) const

## Member Function Documentation

virtual void HashTransformation::Final | ( | byte * | digest | ) | `[inline, virtual, inherited]`

| compute hash for current message, then restart for a new message Precondition: size of digest == DigestSize(). Definition at line 532 of file cryptlib.h. Referenced by PSSR_MEM_Base::ComputeMessageRepresentative(), PKCS1v15_SignatureMessageEncodingMethod::ComputeMessageRepresentative(), EMSA5Pad< T >::ComputeMessageRepresentative(), PKCS5_PBKDF2_HMAC< T >::DeriveKey(), DefaultEncryptor::FirstPut(), PSSR_MEM_Base::RecoverMessageFromRepresentative(), HMAC_Base::TruncatedFinal(), ZlibCompressor::WritePoststreamTail(), and Gzip::WritePoststreamTail().

virtual bool HashTransformation::Verify | ( | const byte * | digest | ) | `[inline, virtual, inherited]`

| verify that digest is a valid digest for the current message, then reinitialize the object Default implementation is to call Final() and do a bitwise comparison between its output and digest. Definition at line 558 of file cryptlib.h. Referenced by HashVerificationFilter::LastPut(), Gunzip::ProcessPoststreamTail(), and PSSR_MEM_Base::RecoverMessageFromRepresentative().

The documentation for this class was generated from the following file:

- cryptlib.h